/*===========================================================================
 * 
 * Project : hostname
 * Author  : Terry 'Mongoose' Hendrix II
 * Website : http://icculus.org/~mongoose
 * Email   : mongooseichiban@gmail.com
 * Object  : MinkApplet
 * License : GPL
 * Comments: I wrote this one day to see how Gnome# applets work.
 *
 *-- TODO ---------------------------------------------------
 *
 *
 *-- History ------------------------------------------------ 
 *
 * 2006.09.02:
 * Mongoose - Created, based on the Gnome# sample panel applet in Portugues
 ==========================================================================*/

/* HOWTO make bonobo see this applet exists:
 *
 * 1. Make a HostnameApplet_Factory.server xml file.  ( I've done this for you. )
 *
 * 2. Copy file to /usr/lib/bonobo/servers/
 *
 * 3. Should be able to see it with bonobo-browser now.
 *
 * 4. You may have to restart GNOME to make it show up in add applet dialog.
 *
 * 5. In GNOME 2.14 it seems to lock up the applet dialog, but if you 
 *    force quit it'll reload your panel and behave as expected.
 */

using System;
using Gtk;
using Gnome;


public class HostnameApplet : Gnome.PanelApplet
{		
	protected HostnameApplet(IntPtr raw) : base (raw) {}
	
	
	public static void Main(string[] args)
	{
		new Gnome.Program("HostnameApplet", "0.1", Gnome.Modules.UI, args);
		PanelAppletFactory.Register(typeof(HostnameApplet));
	}


	public override void Creation()
	{
		mLabel = new Label(System.Net.Dns.GetHostName());
		this.Add(mLabel);
		this.ShowAll();
		
		// Use markup style
		UpdateLabel(); 
		
		// Applet menu
		string xml = "<popup name=\"button3\">" +		
				// Applet menu items
				"<menuitem name=\"Update\" verb=\"UpdateLabel\" _label=\"_Update\" pixtype=\"stock\" pixname=\"gtk-refresh\"/>" +
				"<menuitem name=\"About\" verb=\"ShowAbout\" _label=\"_About\" pixtype=\"stock\" pixname=\"gtk-about\"/>" +
				"</popup>";
				
		this.SetupMenu(xml, 
			new BonoboUIVerb [] {
				new BonoboUIVerb ("UpdateLabel", new ContextMenuItemCallback(UpdateLabel)),
				new BonoboUIVerb ("ShowAbout", new ContextMenuItemCallback(ShowAbout))
			});
	}
	

	public void ShowAbout() 
	{
        string[] authors = {"Terry 'Mongoose' Hendrix II"};
        string[] documenters = {"Terry 'Mongoose' Hendrix II"};

        mAboutDialog = new AboutDialog();
        mAboutDialog.Authors = authors;
        mAboutDialog.Documenters = documenters;
        mAboutDialog.Copyright = "2006 Terry 'Mongoose' Hendrix II";
        mAboutDialog.License = "GPL 2.0";
        mAboutDialog.Name = "HostnameApplet";
        mAboutDialog.Version = "0.1";
        mAboutDialog.Website = "http://icculus.org/~mongoose";
        mAboutDialog.Run();
    }
    

	public void UpdateLabel()
	{
		mLabel.Markup = "<small>" + System.Net.Dns.GetHostName() + "</small>";
	}


	public override string IID {
		get { return "OAFIID:HostnameApplet"; }
	}


	public override string FactoryIID {
		get { return "OAFIID:HostnameApplet_Factory"; }
	}


	Label mLabel;
		
	AboutDialog mAboutDialog;
}